SystemOrganization addCategory: #'CodA-Kernel'!
SystemOrganization addCategory: #'CodA-Anonym Classes'!

!Class methodsFor: '*CodA' stamp: 'mab 11/8/2007 17:08'!
asExtendableMetaFor: anObject
	| anonymClass |
	anonymClass := anObject class subclass: anObject class name asString, 'Meta' instanceVariableNames: 'meta baseClass' classVariableNames:  '' poolDictionaries: '' category: 'CodA-Anonym Classes'.
	anonymClass compile: 'baseClass
	^ baseClass'.
	anonymClass compile: 'baseClass: anObject
	baseClass := anObject'.
	anonymClass compile: 'meta
	^ meta'.
	anonymClass compile: 'meta: anObject
	meta := anObject'.
	anonymClass compile: 'class
	^ self baseClass'.
	anObject become: (anObject as: anonymClass).
	anObject perform: #meta:  with: CodAMeta new.
	anObject perform: #baseClass: with: self.! !

!Class methodsFor: '*CodA' stamp: 'mab 11/8/2007 16:14'!
isExtendableMeta
	^false! !

Object subclass: #CodAMeta
	instanceVariableNames: 'metaComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
accept
	^ self componentAt: #Accept! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:12'!
asExtendableMetaFor: anObject
	^self! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector
	^ metaComponents at: aSelector! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:12'!
componentAt: aSelector put: aComponent
	^ metaComponents at: aSelector put: aComponent! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:14'!
configuration
	^ self componentAt: #Configuration! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
execution
	^ self componentAt: #Execution! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
initialize
	metaComponents := Dictionary new.! !

!CodAMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 16:16'!
isExtendableMeta
	^true! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
protocol
	^ self componentAt: #Protocol! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
queue
	^ self componentAt: #Queue! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
receive
	^ self componentAt: #Receive! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:13'!
send
	^ self componentAt: #Send! !

!CodAMeta methodsFor: 'accessing' stamp: 'mab 11/8/2007 17:12'!
state
	^ self componentAt: #State! !

Object subclass: #CodAMetaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Kernel'!

!Object methodsFor: '*CodA' stamp: 'mab 11/8/2007 16:03'!
meta
	^self class! !

Object subclass: #ObjectMeta
	instanceVariableNames: 'meta baseClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CodA-Anonym Classes'!

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
baseClass
	^ baseClass! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
baseClass: anObject
	baseClass := anObject! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
class
	^ self baseClass! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
meta
	^ meta! !

!ObjectMeta methodsFor: 'as yet unclassified' stamp: 'mab 11/8/2007 17:22'!
meta: anObject
	meta := anObject! !
